package ru.ulstu.report.model.dto;

import org.springframework.format.annotation.DateTimeFormat;
import ru.ulstu.indicator.model.Indicator;
import ru.ulstu.report.model.Report;
import ru.ulstu.report.model.ReportStatus;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class ReportDto {
    private Integer id;
    private Integer reportPeriodId;
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date createDate = new Date();
    private List<ReportValueDto> reportValues = new ArrayList<>();
    private ReportStatus status;

    public ReportDto() {
    }

    public ReportDto(Integer reportPeriodId, List<Indicator> indicators) {
        this.reportPeriodId = reportPeriodId;
        this.reportValues = indicators.stream().map(ReportValueDto::new).toList();
        this.status = ReportStatus.NEW;
    }

    public ReportDto(Report report, List<Indicator> indicators) {
        this.id = report.getId();
        this.reportPeriodId = report.getReportPeriod().getId();
        this.createDate = report.getCreateDate();
        this.reportValues = indicators.stream().map(ReportValueDto::new).toList();
        this.status = report.getStatus();
    }

    public List<ReportValueDto> getReportValues() {
        return reportValues;
    }

    public void setReportValues(List<ReportValueDto> reportValues) {
        this.reportValues = reportValues;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getReportPeriodId() {
        return reportPeriodId;
    }

    public void setReportPeriodId(Integer reportPeriodId) {
        this.reportPeriodId = reportPeriodId;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public ReportStatus getStatus() {
        return status;
    }

    public void setStatus(ReportStatus status) {
        this.status = status;
    }
}
